Code

config.c:store_write_pair(): don't read the byte before a malloc'd buffer.
[git.git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places.  If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
14 die() {
15         echo >&2 "$@"
16         exit 1
17 }
19 usage() {
20         die "Usage: $0 $USAGE"
21 }
23 set_reflog_action() {
24         if [ -z "${GIT_REFLOG_ACTION:+set}" ]
25         then
26                 GIT_REFLOG_ACTION="$*"
27                 export GIT_REFLOG_ACTION
28         fi
29 }
31 git_editor() {
32         : "${GIT_EDITOR:=$(git config core.editor)}"
33         : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
34         case "$GIT_EDITOR,$TERM" in
35         ,dumb)
36                 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
37                 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
38                 echo >&2 "Please set one of these variables to an appropriate"
39                 echo >&2 "editor or run $0 with options that will not cause an"
40                 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
41                 exit 1
42                 ;;
43         esac
44         eval "${GIT_EDITOR:=vi}" '"$@"'
45 }
47 is_bare_repository () {
48         git rev-parse --is-bare-repository
49 }
51 cd_to_toplevel () {
52         cdup=$(git rev-parse --show-cdup)
53         if test ! -z "$cdup"
54         then
55                 cd "$cdup" || {
56                         echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
57                         exit 1
58                 }
59         fi
60 }
62 require_work_tree () {
63         test $(git rev-parse --is-inside-work-tree) = true ||
64         die "fatal: $0 cannot be used without a working tree."
65 }
67 get_author_ident_from_commit () {
68         pick_author_script='
69         /^author /{
70                 s/'\''/'\''\\'\'\''/g
71                 h
72                 s/^author \([^<]*\) <[^>]*> .*$/\1/
73                 s/'\''/'\''\'\'\''/g
74                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
76                 g
77                 s/^author [^<]* <\([^>]*\)> .*$/\1/
78                 s/'\''/'\''\'\'\''/g
79                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
81                 g
82                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
83                 s/'\''/'\''\'\'\''/g
84                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
86                 q
87         }
88         '
89         encoding=$(git config i18n.commitencoding || echo UTF-8)
90         git show -s --pretty=raw --encoding="$encoding" "$1" |
91         LANG=C LC_ALL=C sed -ne "$pick_author_script"
92 }
94 if [ -z "$LONG_USAGE" ]
95 then
96         LONG_USAGE="Usage: $0 $USAGE"
97 else
98         LONG_USAGE="Usage: $0 $USAGE
100 $LONG_USAGE"
101 fi
103 case "$1" in
104         -h|--h|--he|--hel|--help)
105         echo "$LONG_USAGE"
106         exit
107 esac
109 # Make sure we are in a valid repository of a vintage we understand.
110 if [ -z "$SUBDIRECTORY_OK" ]
111 then
112         : ${GIT_DIR=.git}
113         GIT_DIR=$(GIT_DIR="$GIT_DIR" git rev-parse --git-dir) || {
114                 exit=$?
115                 echo >&2 "You need to run this command from the toplevel of the working tree."
116                 exit $exit
117         }
118 else
119         GIT_DIR=$(git rev-parse --git-dir) || {
120             exit=$?
121             echo >&2 "Failed to find a valid git directory."
122             exit $exit
123         }
124 fi
126 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
127     echo >&2 "Unable to determine absolute path of git directory"
128     exit 1
131 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}